#pragma once

/************************************************************************************
 * From spti sample sources
 */

#define SPT_CDB_LENGTH 32
#define SPT_SENSE_LENGTH 32
#define SPTWB_DATA_LENGTH 512

typedef struct _SCSI_PASS_THROUGH_WITH_BUFFERS {
	SCSI_PASS_THROUGH spt;
	ULONG             Filler;      // realign buffers to double word boundary
	UCHAR             ucSenseBuf[SPT_SENSE_LENGTH];
	UCHAR             ucDataBuf[SPTWB_DATA_LENGTH];
} SCSI_PASS_THROUGH_WITH_BUFFERS, * PSCSI_PASS_THROUGH_WITH_BUFFERS;

typedef struct _SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER {
	SCSI_PASS_THROUGH_DIRECT sptd;
	ULONG             Filler;      // realign buffer to double word boundary
	UCHAR             ucSenseBuf[SPT_SENSE_LENGTH];
} SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER, * PSCSI_PASS_THROUGH_DIRECT_WITH_BUFFER;


typedef struct _SCSI_PASS_THROUGH_WITH_BUFFERS_EX {
	SCSI_PASS_THROUGH_EX spt;
	UCHAR             ucCdbBuf[SPT_CDB_LENGTH - 1];       // cushion for spt.Cdb
	ULONG             Filler;      // realign buffers to double word boundary
	STOR_ADDR_BTL8    StorAddress;
	UCHAR             ucSenseBuf[SPT_SENSE_LENGTH];
	UCHAR             ucDataBuf[SPTWB_DATA_LENGTH];     // buffer for DataIn or DataOut
} SCSI_PASS_THROUGH_WITH_BUFFERS_EX, * PSCSI_PASS_THROUGH_WITH_BUFFERS_EX;


typedef struct _SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER_EX {
	SCSI_PASS_THROUGH_DIRECT_EX sptd;
	UCHAR             ucCdbBuf[SPT_CDB_LENGTH - 1];       // cushion for sptd.Cdb
	ULONG             Filler;      // realign buffer to double word boundary
	STOR_ADDR_BTL8    StorAddress;
	UCHAR             ucSenseBuf[SPT_SENSE_LENGTH];
} SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER_EX, * PSCSI_PASS_THROUGH_DIRECT_WITH_BUFFER_EX;


/************************************************************************************
 * From cciss sources
 */

#include <pshpack1.h>

using id_ctlr = struct
{
	unsigned char num_logical_drives;
	uint32_t signature;
	uint32_t running_firm_rev;
	unsigned char rom_firm_rev[4];
	unsigned char hardware_rev;
	unsigned char reserved[4];
	uint32_t drive_present_bit_map;
	uint32_t external_drive_bit_map;
	uint32_t board_id;
	unsigned char reserved2;
	uint32_t non_disk_map;
	unsigned char reserved3[5];
	unsigned char marketing_revision;
	unsigned char controller_flags;
	// unsigned char reserved4[2];
	unsigned char host_flags;
	unsigned char expand_disable_code;
	unsigned char scsi_chip_count;
	uint32_t reserved5;
	uint32_t ctlr_clock;
	unsigned char drives_per_scsi_bus;
	uint16_t big_drive_present_map[8];
	uint16_t big_ext_drive_map[8];
	uint16_t big_non_disk_map[8];

	/* Beyond this point is previously undisclosed stuff which
	   my higher-ups at HP have nonetheless allowed me to put in here.
	   Was told most of this stuff is exposed to some degree by
	   the Array Diagnostics Utility already anyhow, so no big deal.
	*/

	unsigned short task_flags; /* used for FW debugging */
	unsigned char ICL_bus_map; /* Bitmap used for ICL between controllers */
	unsigned char redund_ctlr_modes_support; /* See REDUNDANT MODE VALUES */
#define SUPPORT_ACTIVE_STANDBY 0x01
#define SUPPORT_PRIMARY_SECONDARY 0x02
	unsigned char curr_redund_ctlr_mode; /* See REDUNDANT MODE VALUES */
#define ACTIVE_STANDBY_MODE 0x01
#define PRIMARY_SECONDARY_MODE 0x02
	unsigned char redund_ctlr_status; /* See REDUNDANT STATUS FLAG */
#define PREFERRED_REDUNDANT_CTLR (0x04)
	unsigned char redund_op_failure_code; /* See REDUNDANT FAILURE VALUES */
	unsigned char unsupported_nile_bus;
	unsigned char host_i2c_autorev;
	unsigned char cpld_revision;
	unsigned char fibre_chip_count;
	unsigned char daughterboard_type;
	unsigned char reserved6[2];

	unsigned char access_module_status;
	unsigned char features_supported[12];
	unsigned char bRecRomInactiveRev[4]; /* Recovery ROM inactive f/w revision  */
	unsigned char bRecRomFlags; /* Recovery ROM flags                  */
	unsigned char bPciToPciBridgeStatus; /* PCI to PCI bridge status            */
	unsigned int ulReserved; /* Reserved for future use             */
	unsigned char bPercentWriteCache; /* Percent of memory allocated to write cache */
	unsigned short usDaughterboardCacheSize; /* Total cache board size              */
	unsigned char bCacheBatteryCount; /* Number of cache batteries           */
	unsigned short usTotalMemorySize; /* Total size (MB) of atttached memory */
	unsigned char bMoreControllerFlags; /* Additional controller flags byte    */
	unsigned char bXboardHostI2cAutorev; /* 2nd byte of 3 byte autorev field    */
	unsigned char bBatteryPicRev; /* BBWC PIC revision                   */
	unsigned char bDdffVersion[4]; /* DDFF update engine version          */
	unsigned short usMaxLogicalUnits; /* Maximum logical units supported */
	unsigned short usExtLogicalUnitCount; /* Big num configured logical units */
	unsigned short usMaxPhysicalDevices; /* Maximum physical devices supported */
	unsigned short usMaxPhyDrvPerLogicalUnit; /* Max physical drive per logical unit */
	unsigned char bEnclosureCount; /* Number of attached enclosures */
	unsigned char bExpanderCount; /* Number of expanders detected */
	unsigned short usOffsetToEDPbitmap; /* Offset to extended drive present map*/
	unsigned short usOffsetToEEDPbitmap; /* Offset to extended external drive present map */
	unsigned short usOffsetToENDbitmap; /* Offset to extended non-disk map */
	unsigned char bInternalPortStatus[8]; /* Internal port status bytes */
	unsigned char bExternalPortStatus[8]; /* External port status bytes */
	unsigned int uiYetMoreControllerFlags; /* Yet More Controller flags  */
	unsigned char bLastLockup; /* Last lockup code */
	unsigned char bSlot; /* PCI slot according to option ROM*/
	unsigned short usBuildNum; /* Build number */
	unsigned int uiMaxSafeFullStripeSize; /* Maximum safe full stripe size */
	unsigned int uiTotalLength; /* Total structure length */
	unsigned char bVendorID[8]; /* Vendor ID */
	unsigned char bProductID[16]; /* Product ID */
	unsigned char reserved7[288];

	/* End of previously unexposed stuff */
};

using alarm_struct = struct alarm_struct_t
{
	uint8_t alarm_status;
	uint8_t temp_status;
	uint8_t valid_alarm_bits;
	uint16_t alarm_count;
	uint16_t specific_alarm_counts[8];
};

using inquiry_data = struct inquiry_data_t
{
	uint8_t peripheral_type;
	uint8_t rmb;
	uint8_t versions;
	uint8_t misc;
	uint8_t additional_length;
	uint8_t reserved[2];
	uint8_t support_bits;
	uint8_t vendor_id[8];
	uint8_t product_id[16];
	uint8_t product_revision[4];
};

using sense_bus_param = struct sense_bus_param_t
{
	inquiry_data inquiry;
	uint8_t inquiry_valid;
	uint32_t installed_drive_map;
	uint16_t hot_plug_count[32];
	uint8_t reserved1; /* physical box number? */
	uint8_t reserved2;
	alarm_struct alarm_data;
	uint16_t connection_info; /* 0x01: External Connector is Used? */
	uint8_t scsi_device_revision;
	uint8_t fan_status;
	uint8_t more_inquiry_data[64];
	uint32_t scsi_device_type;
	uint32_t bus_bit_map;
	uint8_t reserved3[8];
	uint8_t scsi_initiator_id;
	uint8_t scsi_target_id;
	uint8_t physical_port[2];
	uint16_t big_installed_drive_map[8];
	uint16_t big_bus_bit_map[8];
	uint16_t big_box_bit_map[8];
	uint8_t installed_box_map;
	uint8_t more_connection_info;
	uint8_t reserved4[2];
	char chassis_sn[40];
};
#include <poppack.h>

